
/*****************************************************************
 *  variables and procedures
 */
extern FILE 	*RED_OUT; 

extern struct index_link_type	*add_index(), *add_index_count();
extern int			free_index_list();


extern char	*red_file_to_string(
  char	*f
); 

extern char    *red_diagram_string(
	redgram	d
	); 
	
extern int red_diagram_size(
	redgram	d, 
	int	*node_count_ptr, 
	int	*arc_count_ptr 
	); 
	
extern int red_diagram_cube_count( 
	redgram	d
	); 

extern int red_diagram_discrete_model_count( 
	redgram	d
	); 

extern int red_diagram_space(
	redgram	d
); 

extern void	red_begin_session(
	int	type_system, 
	char	*session_name, 
	int	process_count
	); 

extern void	red_end_session();


extern void	red_begin_declaration();


extern void	red_end_declaration(); 

extern void 	red_comment(char *com); 

extern void 	red_define_const(char *m, int i); 
  
extern void 	red_declare_variable(
	int vtype, char *name, int lb, int ub
	); 
  
extern void 	red_declare_local_variable(
	int vtype, char *name, int lb, int ub
	); 

extern void	red_begin_mode(int flag_urgent, char *name, char *inv);  

extern void	red_end_mode(); 
  

extern void 	red_transition(char *trigger, char *actions);

extern void 	red_dense_rate(char *vname, char *interval); 

extern void 	red_initial(char *constraint);




extern void 	red_spec(int task, char *constraint);  
  
  

extern int 	red_var_count(); 
  



extern int 	red_var_attribute(int vi, int attr); 

  
  
extern char    *red_var_name(int vi);  
  
  
  

extern int 	red_var_index(char *vname, int pi);
  
  

extern redgram	red_var_active(int vi); 
  
  
  
extern redgram red_var_inactive(int vi);



extern int 	red_clock_count();



extern int 	red_clock_var(int ci); 
  
  
  
  
extern int 	red_zone_index(int ci1, int ci2); 
  
  

extern int 	red_xtion_count(); 
  
  
  

extern int 	red_xtion_attribute(int xi, int attr);
  
  
  
extern redgram	red_xtion_trigger(int xi, int pi); 



extern char 	*red_xtion_action_string(int xi); 
  
  
  
extern char 	*red_xtion_string(int xi); 
  
  
  
extern int 	red_xtion_process(int xi, int i); 
  
  
extern int 	red_process_count();  
  
  
  
extern int 	red_process_xtion_count(int pi); 
  
  
  
extern int 	red_process_xtion(int pi, int ixi);
  
  
  
extern int 	red_mode_count(); 
  
  
  
extern int 	red_mode_attribute(int mi, int attr); 
  
  
  
  
extern int red_mode_rate(int mi, int attr); 
  
  
  
  
extern char 	*red_mode_name(int mi); 
  
  
  
extern int 	red_mode_xtion(int mi, int ixi); 
  
  
extern int 	red_mode_process(int mi, int ipi);  
  
  

extern redgram 	red_mode_invariance(int mi, int pi); 
  
  
extern redgram 	red_declared_invariance(); 




extern int red_system_type(); 
  
  
  
extern int 	red_sync_bulk_depth();  
  
  
  
extern void    red_set_sync_bulk_depth(int d);
   
   
   
extern int red_sync_xtion_count();  
  
  
  
extern int 	red_sync_xtion_party_count(int sxi);
  
  
  
extern redgram red_sync_xtion_trigger(int sxi); 
  
  
  
  
extern char    *red_sync_xtion_action_string(int sxi);
  
  
  
extern char    *red_sync_xtion_string(int sxi); 
  
  
  
extern redgram red_xtion_sync_bulk();
  
  
extern redgram red_xtion_sync_bulk_with_trigger();
  
  
  
extern redgram red_xtion_sync_bulk_whole();
  
  
  
  
extern int 	red_clock_oo();
  
  
  
extern int  	red_hybrid_oo();
  
  
  
  
extern redgram 	red_true(); 
  
  
  
extern redgram 	red_false();
  
  
  


extern redgram red_diagram(char *f, ...); 

  
  
  
extern redgram red_diagram_local(char *f, int pi); 



extern redgram red_and(redgram d1, redgram d2);  
  
  
  
extern redgram red_or(struct red_type *d1, struct red_type *d2);  



extern redgram red_subtract(struct red_type *d1, struct red_type *d2); 

extern redgram red_not(struct red_type *d); 
  
  
  
#define red_discrete_constraint	interval_one_constraint

#define red_zone_constraint	zone_one_constraint

#define red_hybrid_constraint	hybrid_one_constraint

extern redgram red_FM_elm(redgram d, int vi);
  
  
  
extern redgram red_time_bck(struct red_type *dst, struct red_type *path); 

  
extern redgram red_time_fwd(struct red_type *src, struct red_type *path);

extern redgram red_act_string_bck(redgram d, int pi, char *st, int flag_approx);
  
  
  
extern redgram red_act_string_fwd
(redgram d, int pi, char *st, int flag_approx);
  
  
  
extern redgram red_xtion_bck(redgram d, int pi, int xi, int flag_approx); 
  
  
  
  
extern redgram red_xtion_fwd(redgram d, int pi, int xi, int flag_approx); 
  
  


extern struct xtion_type	*parse_xtion(char *xt); 
  
  
  
  
extern redgram red_xtion_string_bck(
	redgram d, 
	int pi, 
	char *xt, 
	int flag_approx
	);  


  
  
extern redgram red_xtion_string_fwd(
	redgram d, int pi, char *xt, int flag_approx
	); 


  
  
extern redgram red_sync_xtion_bck( 
	redgram  ddst, 
	redgram  dpath, 
	int	sxi, 
	int	flag_approx, 
	int	flag_roles
	); 
	
  
  
extern redgram red_sync_xtion_fwd( 
	redgram  dsrc, 
	redgram  dpath, 
	int	sxi, 
	int	flag_approx, 
	int	flag_roles 
	);
  
  

extern redgram red_sync_xtion_bulk_bck(
	redgram ddst, 
	redgram	dpath, 
	int	flag_approx, 
	int 	flag_roles
	); 


  
  
extern redgram red_sync_xtion_bulk_fwd(
	redgram dsrc, 
	redgram dpath, 
	int	flag_approx, 
	int	flag_roles 
	);
  


extern redgram red_sync_xtion_given_bulk_bck( 
	redgram  ddst, 
	redgram  dpath, 
	redgram  dsxt_bulk, 
	int	flag_approx, 
	int	flag_roles
	);
  
  
extern redgram red_sync_xtion_given_bulk_fwd( 
	redgram  dsrc, 
	redgram  dpath, 
	redgram  dsxt_bulk, 
	int	flag_approx, 
	int	flag_roles
	);
  


  
extern redgram red_sync_xtion_all_bck(
	redgram ddst, 
	redgram dpath, 
	int	flag_approx, 
	int	flag_roles
	); 

 
  
  
extern redgram red_sync_xtion_all_fwd( 
	redgram	dsrc, 
	redgram dpath, 
	int	flag_approx, 
	int	flag_roles
	); 


  
  
struct reachable_return_type { 
  int					status, 

#define MASK_REACHABLE_RETURN			(0xF) 
#define	FLAG_RESULT_EARLY_REACHED 		1
#define	FLAG_RESULT_FULL_FIXPOINT		2 
#define	FLAG_RESULT_DEPTH_BOUND_FINISHED	4 

#define	FLAG_COUNTER_EXAMPLE_GENERATED		(0x10)
#define	FLAG_COUNTER_EXAMPLE_NOT_GENERATED	(0x00) 

  					iteration_count, 
  					counter_example_length; 	
  struct counter_example_node_type	*counter_example; 
  struct red_type			*reachability; 
}; 

extern void	red_print_reachable_return(
  int				task_type, 
  struct reachable_return_type	*rr, 
  int				flag_counter_example
); 

	
extern struct reachable_return_type 
  *red_reach_bck(
	redgram	dinit, // redgram for the initial condition. 
	redgram	dpath, // redgram for the path condition. 
	redgram	dgoal, // redgram for the goal condition 
	int 	flag_task, 
	int	flag_parametric_analysis, 
	int	flag_bisim_roles, 
	int	flag_full_reachability, 
	int	flag_reachability_depth_bound, 
	int	flag_counter_example, 
	int 	flag_time_progress, 
	int	flag_normality, 
	int	flag_action_approx, 
	int	flag_reduction, 
	int	flag_zone_approx, 
	int	flag_symmetry, 
	int	flag_zeno, 
	int	flag_coverage, 
	int	flag_print 
	); 

extern struct reachable_return_type 
  *red_reach_fwd( 
	redgram  dinit, // redgram for the initial condition. 
	redgram  dpath, // redgram for the path condition. 
	redgram  dgoal, // redgram for the goal condition 
	int 	flag_task, 
	int	flag_parametric_analysis, 
	int	flag_bisim_roles, 
	int	flag_full_reachability, 
	int	flag_reachability_depth_bound, 
	int	flag_counter_example, 
	int 	flag_time_progress, 
	int	flag_normality, 
	int	flag_action_approx, 
	int	flag_reduction, 
	int	flag_zone_approx, 
	int	flag_symmetry, 
	int	flag_zeno, 
	int	flag_coverage, 
	int	flag_print 
	);
  
extern redgram red_model_check(
	redgram  dinit, 
	redgram  dpath, 
	char	*f, 
 	int	flag_normality, 
	int	flag_action_approx, 
	int	flag_reduction, 
	int	flag_approx, 
	int 	flag_zeno, 
	int	flag_print 
	);
  
  
extern redgram	red_sim_check(
	redgram  dinit, 
	redgram  dinit_sim, 
	char	*role_spec, 
	int	flag_action_approx, 
	int	flag_reduction, 
	int	flag_zone_approx, 
	int	flag_symmetry, 
	int	flag_zeno, 
	int	flag_print 
	);
  
  
  
extern redgram	red_bisim_check(
	redgram  dinit, 
	redgram  dinit_sim, 
	char	*role_spec, 
	int	flag_action_approx, 
	int	flag_reduction, 
	int	flag_zone_approx, 
	int	flag_symmetry, 
	int	flag_zeno, 
	int	flag_print 
	);
  
  
  
extern char
  *red_query_role_string(); 

extern double  
  red_query_system_time(), 
  red_query_user_time(); 

extern int
  red_query_memory(); 
  
  
extern redgram  
  red_query_initial(), 
  red_query_goal(), 
  red_query_abstract_forward_reachability(), 
  red_query_global_invariance(), 
  red_query_deadlock(), 
  red_query_zeno(); 

extern redgram red_norm(
	redgram  d, 
	int	op
	);
  
  
extern redgram red_abs(
	redgram	d, 
	int	flag_oapprox, 
	int	string_roles
	);
  
  
extern redgram red_reduce_symmetry(
	redgram	d, 
	int	flag_symmetry
	);
  
  
redgram red_reduce_inactive(
	redgram	d
	);
  
  
  
extern int 	red_garbage_collect();
  
   
extern int 	red_push(
	redgram	d
	);
  
  
extern redgram red_pop(
	int	i
	);
  
  
extern redgram red_stack(int i);

extern void	red_set_stack(int i, struct red_type *d); 
  

extern void    red_print_variables();
  
extern void    red_print_variable(int vi) ;
  
  
  

extern void    red_print_xtions();
extern void  red_print_xtion(int xi) ;


  
extern void    red_print_sync_xtions();
  
  
extern void    red_print_sync_xtion(int sxi);
  
  
extern void    red_print_game_sync_xtions();
  
  
extern void    red_print_game_sync_xtion(int sxi);
  
  
extern void    red_print_modes();
  
  
  
extern void    red_print_mode(int mi);

  
  
  
extern void    red_print_summary();
  
  
extern void    red_print_dag(redgram d);
  
  
extern void    red_print_simple(redgram d);
  
  
  
extern int 	red_diagram_root_var(
	redgram	d
	);
  
  
extern int 	red_diagram_child_count(
	redgram	d
	);
  
  
extern redgram red_diagram_child(redgram d, int ci);
  
  
  
extern redgram red_diagram_arc_constraint(redgram d, int ci);
  
  
  
  
extern int red_diagram_discrete_arc_lb(redgram d, int ci); 
  
  
  
extern int red_diagram_discrete_arc_ub(redgram d, int ci);
  
  
  
extern int red_diagram_zone_arc_ub(redgram d, int ci);
  
  
extern int red_diagram_hybrid_arc_ubn(redgram d, int ci);
  


extern int red_diagram_hybrid_arc_ubd(redgram d, int ci);
  


extern redgram red_diagram_process_parent(); 
  
  
  
  
extern redgram red_diagram_processed_child(redgram d, int ci);
  
  
  

extern redgram red_diagram_skip_the_level(redgram d);


extern redgram	rec_diagram_process(redgram d); 
  
  
extern redgram red_diagram_process(struct red_type d, struct red_type (*proc)());
  
  
  
  
/* The following procedures are for the control of transition firing. 
 */ 
extern int red_disable_xtion(int xi);
  
  
  
extern int 	red_enable_xtion(int xi);
  
  
extern int 	red_check_xtion_enabled(int xi);
  
  
  
  
extern int 	red_disable_proc(int pi); 
  
  
extern int 	red_enable_proc(int pi);
  
  
extern int red_check_proc_enabled(int pi);  
  
  
extern int red_disable_sync_xtion(int sxi);
  
  
  
extern int red_enable_sync_xtion(int sxi);
  
  
  
extern int red_check_sxi_enabled(int sxi);
  
  
  
extern int red_disable_proc_xtion(int xi, int pi);
  
  
  
  
extern int red_enable_proc_xtion(int xi, int pi); 


  
  
  
  
extern int red_check_enabled_specific(int xi, int pi);



extern redgram	red_first_cube(redgram d), red_next_cube(redgram d); 

extern void 	red_get_cube_discrete_value(
  redgram d, char *vn, int *lbp, int *ubp
); 

